// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.16.0
// source: episodes.sql

package sqlitedb

import (
	"context"
	"database/sql"
	"time"
)

const addEpisode = `-- name: AddEpisode :exec
insert into episodes (podcast_id, name, url, guid, status, published_at)
values (?, ?, ?, ?, ?, ?)
`

type AddEpisodeParams struct {
	PodcastID   int64
	Name        string
	Url         string
	Guid        string
	Status      string
	PublishedAt time.Time
}

func (q *Queries) AddEpisode(ctx context.Context, arg AddEpisodeParams) error {
	_, err := q.db.ExecContext(ctx, addEpisode,
		arg.PodcastID,
		arg.Name,
		arg.Url,
		arg.Guid,
		arg.Status,
		arg.PublishedAt,
	)
	return err
}

const getEpisodeByGUID = `-- name: GetEpisodeByGUID :one
select episode_id, podcast_id, name, url, guid, status, archive_path, published_at from episodes
where guid == ?
`

func (q *Queries) GetEpisodeByGUID(ctx context.Context, guid string) (Episode, error) {
	row := q.db.QueryRowContext(ctx, getEpisodeByGUID, guid)
	var i Episode
	err := row.Scan(
		&i.EpisodeID,
		&i.PodcastID,
		&i.Name,
		&i.Url,
		&i.Guid,
		&i.Status,
		&i.ArchivePath,
		&i.PublishedAt,
	)
	return i, err
}

const getEpisodeIDsByStatus = `-- name: GetEpisodeIDsByStatus :many
select episode_id
from episodes
where status = ?
`

func (q *Queries) GetEpisodeIDsByStatus(ctx context.Context, status string) ([]int64, error) {
	rows, err := q.db.QueryContext(ctx, getEpisodeIDsByStatus, status)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []int64
	for rows.Next() {
		var episode_id int64
		if err := rows.Scan(&episode_id); err != nil {
			return nil, err
		}
		items = append(items, episode_id)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getNextDownloadItem = `-- name: GetNextDownloadItem :one
update episodes
set status = 'downloading'
where episode_id = (
  select min(episode_id)
  from episodes
  where status = 'new')
returning episode_id, podcast_id, name, url, guid, status, archive_path, published_at
`

func (q *Queries) GetNextDownloadItem(ctx context.Context) (Episode, error) {
	row := q.db.QueryRowContext(ctx, getNextDownloadItem)
	var i Episode
	err := row.Scan(
		&i.EpisodeID,
		&i.PodcastID,
		&i.Name,
		&i.Url,
		&i.Guid,
		&i.Status,
		&i.ArchivePath,
		&i.PublishedAt,
	)
	return i, err
}

const setEpisodeArchivePath = `-- name: SetEpisodeArchivePath :exec
update episodes
set archive_path = ?
where episode_id = ?
`

type SetEpisodeArchivePathParams struct {
	ArchivePath sql.NullString
	EpisodeID   int64
}

func (q *Queries) SetEpisodeArchivePath(ctx context.Context, arg SetEpisodeArchivePathParams) error {
	_, err := q.db.ExecContext(ctx, setEpisodeArchivePath, arg.ArchivePath, arg.EpisodeID)
	return err
}

const setEpisodeStatus = `-- name: SetEpisodeStatus :exec
update episodes
set status = ?
where episode_id = ?
`

type SetEpisodeStatusParams struct {
	Status    string
	EpisodeID int64
}

func (q *Queries) SetEpisodeStatus(ctx context.Context, arg SetEpisodeStatusParams) error {
	_, err := q.db.ExecContext(ctx, setEpisodeStatus, arg.Status, arg.EpisodeID)
	return err
}
